> ## Documentation Index
> Fetch the complete documentation index at: https://www.klavis.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Tools

> Lists all tools available for a specific remote MCP server in various AI model formats.

This eliminates the need for manual MCP code implementation and format conversion.
Under the hood, Klavis instantiates an MCP client and establishes a connection 
with the remote MCP server to retrieve available tools.



## OpenAPI

````yaml post /mcp-server/list-tools
openapi: 3.1.0
info:
  title: Klavis AI (https://www.klavis.ai)
  description: Klavis AI - Open Source MCP Integrations for AI Applications
  version: 0.1.0
servers:
  - url: https://api.klavis.ai
    description: US Production server
  - url: https://api.eu.klavis.ai
    description: EU Production server
security: []
paths:
  /mcp-server/list-tools:
    post:
      tags:
        - mcp-server
      summary: List Tools
      description: >-
        Lists all tools available for a specific remote MCP server in various AI
        model formats.


        This eliminates the need for manual MCP code implementation and format
        conversion.

        Under the hood, Klavis instantiates an MCP client and establishes a
        connection 

        with the remote MCP server to retrieve available tools.
      operationId: listServerTools
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ListToolsRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListToolsResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    ListToolsRequest:
      properties:
        serverUrl:
          type: string
          title: Serverurl
          description: The full URL for connecting to the MCP server
        connectionType:
          $ref: '#/components/schemas/ConnectionType'
          description: >-
            The connection type to use for the MCP server. Default is
            STREAMABLE_HTTP.
          default: StreamableHttp
        format:
          $ref: '#/components/schemas/ToolFormat'
          description: >-
            The format to return tools in. Default is MCP Native format for
            maximum compatibility.
          default: mcp_native
        headers:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Headers
          description: Optional HTTP headers to include when connecting to the server
      type: object
      required:
        - serverUrl
      title: ListToolsRequest
    ListToolsResponse:
      properties:
        success:
          type: boolean
          title: Success
          description: Whether the list tools request was successful
        tools:
          anyOf:
            - items: {}
              type: array
            - type: 'null'
          title: Tools
          description: List of tools in the requested format
        format:
          $ref: '#/components/schemas/ToolFormat'
          description: The format of the returned tools
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
          description: Error message, if the request failed
      type: object
      required:
        - success
        - format
      title: ListToolsResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ConnectionType:
      type: string
      enum:
        - SSE
        - StreamableHttp
      title: ConnectionType
    ToolFormat:
      type: string
      enum:
        - openai
        - anthropic
        - gemini
        - mcp_native
      title: ToolFormat
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      description: Your Klavis AI API key.
      scheme: bearer
      x-fern-bearer:
        name: api_key

````